#define NDEBUG // disable assertion messages for boost multi_arrays
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <iostream>
//#include <fcntl.h>
//#include <io.h>
#include <sstream>
#include <algorithm>    // std::copy
#include <boost/array.hpp>
#include <boost/multi_array.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/algorithm/string.hpp>
//#include <cassert>
#include <iterator>
#define _POSIX_SOURCE
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <unistd.h>
#undef _POSIX_SOURCE
//#include <windows.h>
#include <math.h>
#include <map>
#include <time.h>
#include <boost/date_time/gregorian/gregorian.hpp>
//#include <cctype.h>
//#include <cstring.h>

using namespace std;

//static char debugmsg[1000];

char* ut_to_date(long);
char* unix_time_to_datecpp(double);
int DateFromSerial(double , long& , long& , long&, long&, long&, double&);
long isleapyear(long);

static int rowgridoffset=0;

boost::multi_array<char*, 2> static grid(boost::extents[281][10000]);

char* ut_to_date(long unix_time)
{

	time_t t = unix_time; // convert to time_t, ignores msec
	char asctimechar[1000];
	sprintf(asctimechar,"%s",asctime(gmtime(&t)));
	return asctimechar;
}

char* convert(const std::string & s)
{
   char *pc = new char[s.size()+1];
   std::strcpy(pc, s.c_str());
   return pc; 
}

int main(void)
{  
      static char debugmsg[1000];

   //static char filename[1000];
   //strncpy(filename, flnme, 1000);      
   FILE *file;
   int fd;
   fd = open("yf1.txt",O_RDONLY);

   if(fd<0) {
    		printf("open call fail");
 	    }

   file = fdopen ( fd, "r" );
          
   if ( file != NULL )
   {      
      int i=0;  

      char line [ 999999 ]; /* or other suitable maximum line size */       

      //char * writable;    

      while ( fgets ( line, sizeof line, file ) != NULL ) /* read a line */
      {
        
        std::string linestr (line);
	
        if (linestr.size()>1) { 

	std::size_t found = linestr.find("timestamp");        
        std::string yfstrtimestamp = linestr.substr (found,linestr.length());
	found = yfstrtimestamp.find("[");
	yfstrtimestamp = yfstrtimestamp.substr (found+1,yfstrtimestamp.length());
	found = yfstrtimestamp.find("]");
	yfstrtimestamp = yfstrtimestamp.substr (0,found);       

	found = linestr.find("volume");        
        std::string yfvolume = linestr.substr (found+1,linestr.length());
	found = yfvolume.find("[");
	yfvolume = yfvolume.substr (found,yfvolume.length());
	found = yfvolume.find("]");
	yfvolume = yfvolume.substr (0,found);

	found = linestr.find("open");        
        std::string yfopen = linestr.substr (found+1,linestr.length());
	found = yfopen.find("[");
	yfopen = yfopen.substr (found,yfopen.length());
	found = yfopen.find("]");
	yfopen = yfopen.substr (0,found);

	found = linestr.find("high");        
        std::string yfhigh = linestr.substr (found+1,linestr.length());
	found = yfhigh.find("[");
	yfhigh = yfhigh.substr (found,yfhigh.length());
	found = yfhigh.find("]");
	yfhigh = yfhigh.substr (0,found);

	found = linestr.find("low");        
        std::string yflow = linestr.substr (found+1,linestr.length());
	found = yflow.find("[");
	yflow = yflow.substr (found,yflow.length());
	found = yflow.find("]");
	yflow = yflow.substr (0,found);

	found = linestr.find("close");        
        std::string yfclose = linestr.substr (found+1,linestr.length());
	found = yfclose.find("[");
	yfclose = yfclose.substr (found,yfclose.length());
	found = yfclose.find("]");
	yfclose = yfclose.substr (0,found); 

	if (i==0) {

	// This is the solution to split lines	

	vector<string> vs;

	boost::split(vs,yfstrtimestamp,boost::is_any_of(","));   
	std::vector<char*>  YFtimestamp;
	std::transform(vs.begin(), vs.end(), std::back_inserter(YFtimestamp), convert); 
	
	boost::split(vs,yfopen,boost::is_any_of(","));   
	std::vector<char*>  YFopen;
	std::transform(vs.begin(), vs.end(), std::back_inserter(YFopen), convert); 

	boost::split(vs,yfhigh,boost::is_any_of(","));   
	std::vector<char*>  YFhigh;
	std::transform(vs.begin(), vs.end(), std::back_inserter(YFhigh), convert);

	boost::split(vs,yflow,boost::is_any_of(","));   
	std::vector<char*>  YFlow;
	std::transform(vs.begin(), vs.end(), std::back_inserter(YFlow), convert); 

	boost::split(vs,yfclose,boost::is_any_of(","));   
	std::vector<char*>  YFclose;
	std::transform(vs.begin(), vs.end(), std::back_inserter(YFclose), convert); 

	boost::split(vs,yfvolume,boost::is_any_of(","));   
	std::vector<char*>  YFvolume;
	std::transform(vs.begin(), vs.end(), std::back_inserter(YFvolume), convert);   
 
	// End of solution to split lines


	for (size_t i=0;i<YFtimestamp.size();i++)
    		{

char* mydate;
double myYFtimestamp;
myYFtimestamp=atof(YFtimestamp[i]);
//sprintf(debugmsg,"%s","1");MessageBox( NULL, debugmsg,"Debug",MB_OK); 
mydate=unix_time_to_datecpp(myYFtimestamp);
//sprintf(debugmsg,"%s",mydate);MessageBox( NULL, debugmsg,"Debug",MB_OK);
char * writableday;
char * writablemonth;
char * writableyear;
char * writablehour;
char * writableminute;

std::string mydatestr (mydate);                 
std::string daystr = mydatestr.substr (8,2);
writableday = new char[daystr.size() + 1];
std::copy(daystr.begin(), daystr.end(), writableday);
writableday[daystr.size()] = '\0';     
//sprintf(debugmsg,"%s",writableday);MessageBox( NULL, debugmsg,"Debug",MB_OK);
                
std::string mymonthstr = mydatestr.substr (5,2);
writablemonth = new char[mymonthstr.size() + 1];
std::copy(mymonthstr.begin(), mymonthstr.end(), writablemonth);
writablemonth[mymonthstr.size()] = '\0'; 
//sprintf(debugmsg,"%s",writablemonth);MessageBox( NULL, debugmsg,"Debug",MB_OK);  

/*
if (strcmp(writablemonth,"Jan")==0) { mymonthstr="01"; }
if (strcmp(writablemonth,"Feb")==0) { mymonthstr="02"; }
if (strcmp(writablemonth,"Mar")==0) { mymonthstr="03"; }
if (strcmp(writablemonth,"Apr")==0) { mymonthstr="04"; }
if (strcmp(writablemonth,"May")==0) { mymonthstr="05"; }
if (strcmp(writablemonth,"Jun")==0) { mymonthstr="06"; }
if (strcmp(writablemonth,"Jul")==0) { mymonthstr="07"; }
if (strcmp(writablemonth,"Aug")==0) { mymonthstr="08"; }
if (strcmp(writablemonth,"Sep")==0) { mymonthstr="09"; }
if (strcmp(writablemonth,"Oct")==0) { mymonthstr="10"; }
if (strcmp(writablemonth,"Nov")==0) { mymonthstr="11"; }
if (strcmp(writablemonth,"Dec")==0) { mymonthstr="12"; }


writablemonth = new char[mymonthstr.size() + 1];
std::copy(mymonthstr.begin(), mymonthstr.end(), writablemonth);
writablemonth[mymonthstr.size()] = '\0';  

*/

std::string yearstr = mydatestr.substr (0,4);
writableyear = new char[yearstr.size() + 1];
std::copy(yearstr.begin(), yearstr.end(), writableyear);
writableyear[yearstr.size()] = '\0'; 
//sprintf(debugmsg,"%s",writableyear);MessageBox( NULL, debugmsg,"Debug",MB_OK);  

std::string hourstr = mydatestr.substr (11,2);
writablehour = new char[hourstr.size() + 1];
std::copy(hourstr.begin(), hourstr.end(), writablehour);
writablehour[hourstr.size()] = '\0';  
//sprintf(debugmsg,"%s",writablehour);MessageBox( NULL, debugmsg,"Debug",MB_OK);

std::string minutestr = mydatestr.substr (14,2);
writableminute = new char[minutestr.size() + 1];
std::copy(minutestr.begin(), minutestr.end(), writableminute);
writableminute[minutestr.size()] = '\0';
//sprintf(debugmsg,"%s",writableminute);MessageBox( NULL, debugmsg,"Debug",MB_OK);

char datetimestr[1000];
strcpy (datetimestr,writableyear);
strcat (datetimestr,".");
strcat (datetimestr,writablemonth);
strcat (datetimestr,".");
strcat (datetimestr,writableday);

char datetimestr2[1000];
strcpy (datetimestr2,writablehour);
strcat (datetimestr2,":");
strcat (datetimestr2,writableminute);

		grid[rowgridoffset+1][i+1]=datetimestr;
		grid[rowgridoffset+2][i+1]=datetimestr2;
		grid[rowgridoffset+3][i+1]=YFopen[i];
		grid[rowgridoffset+4][i+1]=YFhigh[i];
		grid[rowgridoffset+5][i+1]=YFlow[i];
		grid[rowgridoffset+6][i+1]=YFclose[i];
		grid[rowgridoffset+7][i+1]=YFvolume[i];

if (i==0) {
memmove (YFopen[i], YFopen[i]+1, strlen (YFopen[i]+1) + 1);
grid[rowgridoffset+3][i+1]=YFopen[i];

memmove (YFhigh[i], YFhigh[i]+1, strlen (YFhigh[i]+1) + 1);
grid[rowgridoffset+4][i+1]=YFhigh[i];

memmove (YFlow[i], YFlow[i]+1, strlen (YFlow[i]+1) + 1);
grid[rowgridoffset+5][i+1]=YFlow[i];

memmove (YFclose[i], YFclose[i]+1, strlen (YFclose[i]+1) + 1);
grid[rowgridoffset+6][i+1]=YFclose[i];

memmove (YFvolume[i], YFvolume[i]+1, strlen (YFvolume[i]+1) + 1);
grid[rowgridoffset+7][i+1]=YFvolume[i];
}


if (strcmp(YFopen[i],"null")==0 or strcmp(YFhigh[i],"null")==0 or strcmp(YFlow[i],"null")==0 or strcmp(YFclose[i],"null")==0 or strcmp(YFvolume[i],"null")==0) { 
	grid[rowgridoffset+3][i+1]=grid[rowgridoffset+6][i];
	grid[rowgridoffset+4][i+1]=grid[rowgridoffset+6][i];
	grid[rowgridoffset+5][i+1]=grid[rowgridoffset+6][i];
	grid[rowgridoffset+6][i+1]=grid[rowgridoffset+6][i];
	grid[rowgridoffset+7][i+1]="0";
 }


			if (i>0) 
			{
			cout << grid[rowgridoffset+1][i+1] << "," << grid[rowgridoffset+2][i+1] << "," << grid[rowgridoffset+3][i+1] << "," << grid[rowgridoffset+4][i+1] << "," << grid[rowgridoffset+5][i+1] << "," << grid[rowgridoffset+6][i+1] << "," << grid[rowgridoffset+7][i+1] << "\n";
			}		     	
	 	        
		} 

	}

	i++;  
  
                         }
      }    	    	
             
   fclose ( file );
   close (fd); 
      	
   }
   else
   {
      perror ( "yf1.txt" ); /* why didn't the file open? */
	strerror(errno);
   }

   return 0; 
   
}

char* unix_time_to_datecpp(double DateSerialchar)
  {


//static char DateSerialcharr[1000];
//    strncpy(DateSerialcharr, DateSerialchar, 1000);
    double dblDateSerialchar=DateSerialchar;

 double DateSerialdbl=dblDateSerialchar;
static long Yearlng;
static long Monthlng;
static long Daylng;
static long Hourlng;
static long Minutelng;
static double Seconddbl;

//DateSerialdbl=1111111111;
static char debugmsg[1000];
//sprintf(debugmsg,"%f",DateSerialdbl);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

DateFromSerial(DateSerialdbl , Yearlng , Monthlng , Daylng,Hourlng,Minutelng,Seconddbl);

long Secondlng=Seconddbl;

//sprintf(debugmsg,"%u",Yearlng);MessageBox( NULL, debugmsg,"Debug",MB_OK); 

char Yearlngchar[1000];
sprintf(Yearlngchar,"%u",Yearlng);

char Monthlngchar[1000];
sprintf(Monthlngchar,"%u",Monthlng);

char Daylngchar[1000];
sprintf(Daylngchar,"%u",Daylng);

char Hourlngchar[1000];
sprintf(Hourlngchar,"%u",Hourlng);

char Minutelngchar[1000];
sprintf(Minutelngchar,"%u",Minutelng);

char Seconddblchar[1000];
sprintf(Seconddblchar,"%u",Secondlng);


//std::string Yearlngcharstr (Yearlngchar);
//std::string Monthlngcharstr (Monthlngchar);
//std::string Daylngcharstr (Daylngchar);
//std::string Hourlngcharstr (Hourlngchar);
//std::string Minutelngcharstr (Minutelngchar);
//std::string Seconddblcharstr (Seconddblchar);

//std::string Yearlngcharstr=boost::lexical_cast<std::string>(Yearlngchar);
//std::string Monthlngcharstr=boost::lexical_cast<std::string>(Monthlngchar);
//std::string Daylngcharstr=boost::lexical_cast<std::string>(Daylngchar);
//std::string Hourlngcharstr=boost::lexical_cast<std::string>(Hourlngchar);
//std::string Minutelngcharstr=boost::lexical_cast<std::string>(Minutelngchar);
//std::string Seconddblcharstr=boost::lexical_cast<std::string>(Seconddblchar);

char yearn[1000];
char monthn[1000];
char dayn[1000];
char hourn[1000];
char minuten[1000];
char secondn[1000];

std::size_t size = std::strlen( Yearlngchar );
if (size==1) {
strcpy (yearn,"000");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="000"+Yearlngcharstr;
}
if (size==2) {
strcpy (yearn,"00");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="00"+Yearlngcharstr;
}
if (size==3) {
strcpy (yearn,"0");
strcat (yearn,Yearlngchar);
//Yearlngcharstr="0"+Yearlngcharstr;
}
if (size==4) {
strcpy (yearn,Yearlngchar);
//Yearlngcharstr="0"+Yearlngcharstr;
}

size = std::strlen( Monthlngchar );
if (size==1) {
strcpy (monthn,"0");
strcat (monthn,Monthlngchar);
//Monthlngcharstr="0"+Monthlngcharstr;
}
if (size==2) {
strcpy (monthn,Monthlngchar);
//Monthlngcharstr="0"+Monthlngcharstr;
}

size = std::strlen( Daylngchar );
if (size==1) {
strcpy (dayn,"0");
strcat (dayn,Daylngchar);
//Daylngcharstr="0"+Daylngcharstr;
}
if (size==2) {
strcpy (dayn,Daylngchar);
//Daylngcharstr="0"+Daylngcharstr;
}

size = std::strlen( Hourlngchar );
if (size==1) {
strcpy (hourn,"0");
strcat (hourn,Hourlngchar);
//Hourlngcharstr="0"+Hourlngcharstr;
}
if (size==2) {
strcpy (hourn,Hourlngchar);
//Hourlngcharstr="0"+Hourlngcharstr;
}

size = std::strlen( Minutelngchar );
if (size==1) {
strcpy (minuten,"0");
strcat (minuten,Minutelngchar);
//Minutelngcharstr="0"+Minutelngcharstr;
}
if (size==2) {
strcpy (minuten,Minutelngchar);
//Minutelngcharstr="0"+Minutelngcharstr;
}

size = std::strlen( Seconddblchar );
if (size==1) {
strcpy (secondn,"0");
strcat (secondn,Seconddblchar);
//Seconddblcharstr="0"+Seconddblcharstr;
}
if (size==2) {
strcpy (secondn,Seconddblchar);
//Seconddblcharstr="0"+Seconddblcharstr;
}

//sprintf(debugmsg,"%s",monthn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",dayn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",hourn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",minuten);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",secondn);MessageBox( NULL, debugmsg,"Debug",MB_OK);

//std::string fulldatetime;

//fulldatetime=Yearlngcharstr+"-"+Monthlngcharstr+"-"+Daylngcharstr+" "+Hourlngcharstr+":"+Minutelngcharstr;

//char fulldatetimechar = new char[1000];
char fulldatetimechar[1000];
strcpy (fulldatetimechar,yearn);
strcat (fulldatetimechar,"-");
strcat (fulldatetimechar,monthn);
strcat (fulldatetimechar,"-");
strcat (fulldatetimechar,dayn);
strcat (fulldatetimechar," ");
strcat (fulldatetimechar,hourn);
strcat (fulldatetimechar,":");
strcat (fulldatetimechar,minuten);
//strcat (fulldatetimechar,":");
//strcat (fulldatetimechar,secondn);

//std::string fulldatetimecharstr=boost::lexical_cast<std::string>(fulldatetimechar);
//std::string fulldatetimecharstr(1, fulldatetimechar); std::cout << fulldatetimecharstr << std::endl;
//std::cout << std::string(1, fulldatetimechar) << std::endl;

//sprintf(debugmsg,"%s",monthn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",dayn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",hourn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",minuten);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",secondn);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%s",fulldatetimechar);MessageBox( NULL, debugmsg,"Debug",MB_OK); 


//writable = new char[S1str.size() + 1];
//std::copy(S1str.begin(), S1str.end(), writable);
//writable[S1str.size()] = '\0'; // don't forget the terminating 0


//char *fulldatetimechar = new char[fulldatetime.length() + 1]; // or
//std::strcpy(fulldatetimechar, fulldatetime.c_str());
      
//----
   return(fulldatetimechar);
}

int DateFromSerial(double DateSerial , long & Year , long & Month , long & Day,long & Hour,long & Minute,double & Second) {
    //declare
    //long daysCount , dayOfMonth , dayTotal;//, isLeapYearlng;

static char debugmsg[1000];
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);


long hoursrest=0;
    //string DateSerialstr=Format$("%12.0f", DateSerial)

    double secondsrest=fmod(DateSerial,86400);



    //defstr amodstr="86400"

    //defdbl secondsrest=val(varptr$(rqmod(varptr(DateSerialstr),varptr(amodstr))))

    Second=secondsrest;

    double secondsrest2=secondsrest;

    secondsrest=fmod(secondsrest2, 60);


 
    Second=secondsrest;  

    long minutesrest=secondsrest2 / 60;

 

    long minutesrest2=minutesrest;

    minutesrest=minutesrest2 % 3600;



    Minute=minutesrest;      

    if (minutesrest % 60==0) {
    minutesrest2=minutesrest;
    minutesrest=0;
    }         



    Minute=minutesrest % 60;  

  

    hoursrest=minutesrest2 / 60;



    Hour=hoursrest;       
    
    DateSerial=DateSerial/24/60/60;    
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);


    long daysCount=0 , dayOfMonth=0 , dayTotal=0;
    DateSerial=DateSerial+719163;
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);

//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",dayOfMonth);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",daysCount);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%f",DateSerial);MessageBox( NULL, debugmsg,"Debug",MB_OK);


    //initialize
    Year = 1;
    Month = 1;
    daysCount = DateSerial - 1;
//sprintf(debugmsg,"%u",daysCount);MessageBox( NULL, debugmsg,"Debug",MB_OK);


    //pre-process
    if (daysCount > 146096) {
        Year = Year + (trunc(round(daysCount) / 146097)) * 400;
        daysCount = (daysCount % 146097);
    }



    if (daysCount > 36523) {
        dayTotal = trunc(round(daysCount) / 36524);
//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
        if (dayTotal < 4) {
            Year = Year + (dayTotal * 100);
            daysCount = (daysCount % 36524);
	}
        else {
             Year = Year + 300;
             daysCount = 36524;
	     }        
    }


 
    if (daysCount > 1460) {
        Year = Year + (trunc(round(daysCount) / 1461)) * 4;
        daysCount = (daysCount % 1461);
    }


 
    if (daysCount > 364) {
        dayTotal = trunc(round(daysCount) / 365);
//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
        if (dayTotal < 4) {
            Year = Year + dayTotal;
            daysCount = (daysCount % 365);
	}
        else {
            	Year = Year + 3;
            	daysCount = 365;
        	}
    }



    //process
    Day = daysCount + 1;
    dayOfMonth = 1040154527;
    //isLeapYearlng=isleapyear(Year);
    if ((Day > 58) && (isleapyear(Year))) dayOfMonth = (dayOfMonth + 32);

//sprintf(debugmsg,"%u",dayOfMonth);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",dayTotal);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",Day);MessageBox( NULL, debugmsg,"Debug",MB_OK);
//sprintf(debugmsg,"%u",Month);MessageBox( NULL, debugmsg,"Debug",MB_OK);

    do
	{
        dayTotal = (dayOfMonth & 31);
        if (dayTotal >= Day) break;
        Day = Day - dayTotal;
        Month = Month + 1;
        dayOfMonth = (trunc(round(dayOfMonth) / 32));
        if (dayOfMonth == 0) dayOfMonth = 1072692223;
    	}
    	while (1==1);
//sprintf(debugmsg,"%s","17");MessageBox( NULL, debugmsg,"Debug",MB_OK); 


    //exit
    return (0);
}

long isleapyear(long year)
{
    if ( ( (year % 4) == 0) && ( (year % 100) > 0) || ( (year % 400) == 0) ) return 1;
    else return 0;
}
